warning('off','all')

markercell{1,1} = handles.markercell;
IDsforExport_2{1,1} = handles.IDsforExport_1;
IDspp = handles.datapp;
IDspp = {IDspp(:,end)};
IDsforExport_1 = [IDsforExport_2; IDspp];

edge = handles.edge;
data_for_HMs{1,1}{1,1} = handles.data_for_HMs;
data_for_HMs{1,1}{1,1} = [data_for_HMs{1,1}{1,1} IDsforExport_1{1,1}];
datapp1{1,1}{1,1} = handles.datapp;

data_for_HMs = [data_for_HMs{1,1}; datapp1{1,1}];
newIDsXYZ = data_for_HMs;
%% Scaling
h = waitbar(20/100,'Scaling in progress...');

for ps = 1:length(newIDsXYZ)
	Structure_dataandheaderX = newIDsXYZ{ps,1}(:,1);
	Structure_dataandheaderY = newIDsXYZ{ps,1}(:,2);
	Structure_dataandheaderZ = newIDsXYZ{ps,1}(:,3);
	minimaXi{ps} = min(Structure_dataandheaderX);
	minimaYi{ps} = min(Structure_dataandheaderY);
	minimaZi{ps} = min(Structure_dataandheaderZ);
	maximaXi{ps} = max(Structure_dataandheaderX);
	maximaYi{ps} = max(Structure_dataandheaderY);
	maximaZi{ps} = max(Structure_dataandheaderZ);
end

% identifying the biggest section
a = cell2mat(minimaXi);
b = cell2mat(maximaXi);
c = b-a;                    % X-diffs of all
bXdiff = max(c);            % biggest X-diff
d = bXdiff/edge;
e = ceil(d);
bXdme = e*edge;             % multiple of edge and max X-dimension of all sections

a1 = cell2mat(minimaYi);
b1 = cell2mat(maximaYi);
c1 = b1-a1;                 % Y-diffs of all
bYdiff = max(c1);           % biggest Y-diff
d1 = bYdiff/edge;
e1 = ceil(d1);
bYdme = e1*edge;             % multiple of edge and max Y-dimension of all sections

a2 = cell2mat(minimaZi);
b2 = cell2mat(maximaZi);
c2 = b2-a2;                 % Z-diffs of all
bZdiff = max(c2);           % biggest Z-diff
d2 = bZdiff/edge;
e2 = ceil(d2);
bZdme = e2*edge;             % multiple of edge and max Z-dimension of all sections

% lay foundation for a grid over the data
l1 = cell2mat(minimaXi);
l2 = cell2mat(minimaYi);
l3 = cell2mat(minimaZi);
l4 = cell2mat(maximaXi);
l5 = cell2mat(maximaYi);
l6 = cell2mat(maximaZi);
    
smallestX =  min(l1); 
smallestY = min(l2); 
smallestZ =  min(l3); 
biggestX =  max(l4); 
biggestY =  max(l5); 
biggestZ =  max(l6); 

one = smallestX;
two = biggestX;
diffX = two-one;
three = smallestY;
four = biggestY;
diffY = four-three;
five = smallestZ;
six = biggestZ;
diffZ = six-five;

aX = abs(bXdme-diffX);   %difference of current xdiff to max&multiple 
aY = abs(bYdme-diffY);   %difference of current ydiff to max&multiple 
aZ = abs(bZdme-diffZ);   %difference of current zdiff to max&multiple 

aX2 = aX/2;
aY2 = aY/2;
aZ2 = aZ/2;

onenew  = one-aX2;      %new xmin for all sections
twonew  = two+aX2;      %new xmax for all sections 
threenew = three-aY2;   %new ymin for all sections
fournew= four+aY2;      %new ymax for all sections 
fivenew = five-aZ2;   %new ymin for all sections
sixnew= six+aZ2;      %new ymax for all sections 

newIDmin = 111111;
newIDmax = 999999;

newXYZmin = [onenew threenew fivenew];  %new min points for all sec
newXYZmax = [twonew fournew sixnew];   %new max points for all sec

AnewXYZmin = [onenew threenew fivenew newIDmin];  %new min points for all sec
AnewXYZmax = [twonew fournew sixnew newIDmax];   %new max points for all sec

for p = 1:length(newIDsXYZ)
	Newdata{p,1} = [newIDsXYZ{p,1}; AnewXYZmin; AnewXYZmax];
end
%%
% calculating the new matrices and differences with one MAXPOINT and one
% MINPOINT that is max and min of all section to achieve uniform grid size
% and scaling to the biggest section

for ps = 1:length(Newdata)
	Structure_dataandheaderX2 = Newdata{ps,1}(:,1);
	Structure_dataandheaderY2 = Newdata{ps,1}(:,2);
	Structure_dataandheaderZ2 = Newdata{ps,1}(:,3);
	aminimaXi{ps} = min(Structure_dataandheaderX2);
	aminimaYi{ps} = min(Structure_dataandheaderY2);
	aminimaZi{ps} = min(Structure_dataandheaderZ2);
	amaximaXi{ps} = max(Structure_dataandheaderX2);
	amaximaYi{ps} = max(Structure_dataandheaderY2);
	amaximaZi{ps} = max(Structure_dataandheaderZ2);
end


minimaX2 = cell2mat(aminimaXi);
minimaY2 = cell2mat(aminimaYi);
minimaZ2 = cell2mat(aminimaZi);
maximaX2 = cell2mat(amaximaXi);
maximaY2 = cell2mat(amaximaYi);
maximaZ2 = cell2mat(amaximaZi);

minimaX1 = min(minimaX2);
minimaY1 = min(minimaY2);
minimaZ1 = min(minimaZ2);
maximaX1 = max(maximaX2);
maximaY1 = max(maximaY2);
maximaZ1 = max(maximaZ2);

l1new = minimaX1;
l2new = minimaY1;
l3new = minimaZ1;
l4new = maximaX1;
l5new = maximaY1;
l6new = maximaZ1;

one1 = l1new;
two1 = l4new;
diffX1 = two1-one1;
three1 = l2new;
four1 = l5new;
diffY1 = four1-three1;
five1 = l3new;
six1 = l6new;
diffZ1 = six1-five1;


%% Binning cells in established 3D grid
close(h)
h = waitbar(0/100,'Density analysis in progress...');
    


for p = 1:length(Newdata)
        Newdat = Newdata{p,1};
    
        % sort and bucket the x values
        X = sortrows(Newdat,1);
        Xmin = min(X(:,1));
        X1 = diffX1/edge;
        X2 = round(X1);

        for xi = 1:X2
            X3(xi) = Xmin + (xi*(edge));
        end

        for xii = 1:X2
            if xii == 1
                X4 = find(X(:,1) <= X3(xii));
            else
                X5{xii} = find(X(:,1) <= X3(xii) & X(:,1) > X3(xii-1));
            end
        end
        X6 = {X4};
        X5(1,1) = X6;

        for xj = 1:length(X5)
            Xend{xj} = X(min(X5{1,xj}):max(X5{1,xj}),1:3);
        end

        % sort and bucket the y value
        Y = sortrows(Newdat,2);
        Ymin = min(Y(:,2));
        Y1 = diffY1/edge;
        Y2 = round(Y1);

        for yi = 1:Y2
            Y3(yi) = Ymin + (yi*(edge));
        end
        for yii = 1:Y2
            if yii == 1
                Y4 = find(Y(:,2) <= Y3(yii));
            else
                Y5{yii} = find(Y(:,2) <= Y3(yii) & Y(:,2) > Y3(yii-1));
            end
        end
        Y6 = {Y4};
        Y5(1,1) = Y6;

        for yj = 1:length(Y5)
            Yend{yj} = Y(min(Y5{1,yj}):max(Y5{1,yj}),1:3);
        end

        % sort and bucket the z value
        Z = sortrows(Newdat,3);
        Zmin = min(Z(:,3));
        Z1= diffZ1/edge;
        Z2 = round(Z1);

        for hz = 1:Z2
            Z3(hz) = Zmin + (hz*(edge));
        end
        for iz = 1:Z2
            if iz == 1
                Z4= find(Z(:,3) <= Z3(iz));
            else
                Z5{iz} = find(Z(:,3) <= Z3(iz) & Z(:,3) > Z3(iz-1));
            end
        end
        Z6 = {Z4};
        Z5(1,1) = Z6;

        for jz = 1:length(Z5)
            Zend{jz} = Z(min(Z5{1,jz}):max(Z5{1,jz}),1:3);
        end

% calculates the projection of 3D data on a 2D plane; each pixel (as
% defined by "edge" now)contains the xyz values of the cells within its boarders
        COXY = cell(length(Xend),length(Yend)); % preallocate
        m = length(Yend);
        n = length(Xend);
        
        for y = 1:m
            for x = 1:n
                COXY{x,y} = intersect(Xend{1,x},Yend{1,y},'rows');
            end
        end
        clearvars x y n m
        
%  extracts from the projected data the values beloging to each z plane
%  with anedge length as identified above
        COXYZc = cell(1,Z2); % preallocate
        for i = 1:Z2
            COXYZc{1,i} = cell(length(Xend),length(Yend)); % preallocate
        end
        m = length(Yend);
        n = length(Xend);
        
        for z = 1:Z2
            COXYZ = COXYZc{1,z};
            for y = 1:m
                for x = 1:n
                    COXYZ{x,y}  = intersect(COXY{x,y}, Zend{1,z},'rows');
                end
            end
            COXYZp{1,z} = COXYZ;
        end
        clearvars x y n m

%%      
% Computes the number of cells in given voxel and stores them as 2D
% matrices of each z-slice (with specified edge length); also computes the
% maximum cell number in one voxel from the whole slice
        
        for z = 1:Z2
            for y11 = 1:Y2
                for x11 = 1:X2
                    fe = size(COXYZp{1,z}{x11,y11});
                    num2{x11,y11} = fe(1);
                end
            end
            nummat = cell2mat(num2);
            nump{z} = nummat;
    
            M = max(nummat);
            MaxpP{z} = max(M);
            kkk  = cell2mat(MaxpP);
            kk = max(kkk);
        end
      
    COXYZpPS{p} = COXYZp;
    DenspPS{p} = nump;
    MaxpS{p} = kk;
    Newdata1{p} = Newdat; 
    Maximaperplane{p} = MaxpP; 

    [Xs,Ys,Zs] = meshgrid(1:Y1,1:X1,1:Z1);
    Xss{p} = Xs;
    Yss{p} = Ys;
    Zss{p} = Zs;

    clearvars -except Values Densities data AnalysisMatrix dataD Vs edge DenspPS MaxpS marker...
    Names COXYZpPS MaxpS minimaX minimaY minimaZ maximaX maximaY maximaZ bXdme...
    bYdme Single1 filename l1new l2new l3new Xss1 Yss1 Zss1 p op...
    allthresholds Names csvFiles k pathname Number_of_markers IDsforExport_1...
    falsepositive Threshold IDsforExport filename1 diffX1 diffY1 diffZ1...
    currentFolder theName Maximaperplane bZdme Newdata1 IDsXYZ newIDsXYZ data1...
    data_for_HMs data_for_subpops pathe count Newdata Newdata1 COXYZpPS DenspPS...
    MaxpS Newdata1 Maximaperplane Xss Yss Zss markercell wait Imaris LTformat confirmed textImaris textLTformat h...
    handles eventdata hObject PathName FileName flipid mirrorid saveID pathname aw handles
    waitbar( p/length(Newdata))
    
end
    
close(h)
h = waitbar(80/100,'Density analysis done. Plotting in progress...');   

%% MCD plots

% Maximum value of one voxel in dataset is generated
fff = cell2mat(MaxpS);
Max = max(fff(1,length(MaxpS)-1));
Maxpp = max(fff);

%calculate from analysis volume to 1mm3
AnlVol = edge.^3;
VolFact = (1000.^3)/(edge.^3);
MaxppVF = Maxpp * VolFact;
MaxppValue = Maxpp * MaxppVF;

NewMatrix = cell(size((DenspPS{1,1}{1,1}),1), size((DenspPS{1,1}{1,1}),2)); % preallocate


for i = 1:length(DenspPS)
	for k = 1:size((DenspPS{1,1}{1,1}),1)
        for l = 1:size((DenspPS{1,1}{1,1}),2)
            for m = 1:length(DenspPS{1,i})
                Vec(1,m) = DenspPS{1,i}{1,m}(k,l);
                MaxPerPlane = max(Vec);
                NewMatrix{k,l} = MaxPerPlane;
            end
        end
    end
	NewMatrix_for_all{i} = NewMatrix;
	clearvars NewMatrix
end

close(h)

% Parentpopulation plot(s) is/are generated

ParentPop = cell2mat(NewMatrix_for_all{1,length(DenspPS)});

fig = figure('Units','normalized', 'OuterPosition',[0.3 0.3 0.3 0.5],'visible','off');
contourf(ParentPop,Maxpp+1,'LineStyle','none')
myColorMap = jet(Maxpp+1); 
myColorMap(1, :) = [1 1 1];
colormap(myColorMap);
caxis([-0.5 Maxpp+0.5])
daspect([1,1,1])
%set(gca,'outerposition',[0.002 0 0.996 1],'units','normalized')
%set(gca, 'LooseInset', [0,0,0,0]);
set(gca,'YTick',[]);

ch = colorbar('Southoutside');
ax = gca;
axpos = ax.Position;
cpos = ch.Position;
cpos(3) = 0.25*cpos(3);
cpos(2) = 0.8*cpos(2);
ch.Position = cpos;
ax.Position = axpos;
cha1 = get(ch,'Xtick');
cha = [cha1 Maxpp];
if cha(1,end-1) == cha(1,end)
    set(ch,'Xtick',cha1)
else
    set(ch,'Xtick',cha)
end
    
xTicks = get(ch, 'xtick');
xTicks2 = xTicks*MaxppVF;
xticks3 = num2cell(xTicks2);
xticks4 = cell(1,length(xticks3));
xticks4{1,1} = num2str(0);
xticks4{1,end} = num2str(xticks3{1,end}, '%10.1e');
for u = 2:(length(xticks3)-1)
	xticks4{1,u} = ' ';
end
set(ch,'XTickLabel',(xticks4))

if flipid == 1 & mirrorid == 0
    set(gca,'XDir','Reverse')
elseif flipid == 0 & mirrorid == 1
    set(gca,'YDir','Reverse')
elseif flipid == 1 & mirrorid == 1
    set(gca,'XDir','Reverse')
    set(gca,'YDir','Reverse')
end

str = 'parentpopulation';
ka = '_MaxCellDensity_';

if saveID == 1
    FileName1 = [FileName(1:end-4) ka str];
    FileName2 = fullfile(PathName, FileName1);
else
    FileName1 = [FileName(1:end-4) ka str];
    FileName2 = fullfile(PathName, FileName1);
end

set(gcf,'PaperPositionMode','auto')
print(fig,[FileName2 '.tif'],'-dtiff','-r300')
close(fig) 
BaseImg = imread([FileName2 '.tif']);
BaseGr = rgb2gray(BaseImg);
clearvars ag ka ai str FileName1 FileName2 BaseImg fig


% Subpopulation plots and overlays with pp are generated
for i = 1:length(DenspPS)-1
    NoCell = cell2mat(NewMatrix_for_all{1,i});
	fig1 = figure('Units','normalized', 'OuterPosition',[0.3 0.3 0.3 0.5]);
    set(fig1,'visible','off');
	contourf(NoCell,Maxpp+1,'LineStyle','none')
	myColorMap = jet(Maxpp+1); 
    myColorMap(1, :) = [1 1 1];
	colormap(myColorMap);
	caxis([-0.5 Maxpp+0.5])
	daspect([1,1,1])
	set(gca,'YTick',[]);
    
    ch = colorbar('Southoutside');
    ax = gca;
    axpos = ax.Position;
	cpos = ch.Position;
    cpos(3) = 0.25*cpos(3);
    cpos(2) = 0.8*cpos(2);
    ch.Position = cpos;
    ax.Position = axpos;
	cha1 = get(ch,'Xtick');
	cha = [cha1 Maxpp];
	if cha(1,end-1) == cha(1,end)
        set(ch,'Xtick',cha1)
    else
        set(ch,'Xtick',cha)
    end

    xTicks = get(ch, 'xtick');
    xTicks2 = xTicks*MaxppVF;
    xticks3 = num2cell(xTicks2);
    xticks4 = cell(1,length(xticks3));
    xticks4{1,1} = num2str(0);
    xticks4{1,end} = num2str(xticks3{1,end}, '%10.1e');
    for u = 2:(length(xticks3)-1)
        xticks4{1,u} = ' ';
    end
    set(ch,'XTickLabel',(xticks4))
    
	%set(gca,'outerposition',[0.002 0 0.996 1],'units','normalized')
	%set(gca,'LooseInset', [0,0,0,0]);
	%set(gca,'YTick',[]);
    
    if flipid == 1 & mirrorid == 0
        set(gca,'XDir','Reverse')
    elseif flipid == 0 & mirrorid == 1
        set(gca,'YDir','Reverse')
    elseif flipid == 1 & mirrorid == 1
        set(gca,'XDir','Reverse')
        set(gca,'YDir','Reverse')
    end

	str = 'Gate';
	ka = '_MaxCellDensity_';
        
    if saveID == 1
        FileName1 = [FileName(1:end-4) ka str];
        FileName2 = fullfile(PathName, FileName1);
    else
        FileName1 = [FileName(1:end-4) ka str];
        FileName2 = fullfile(PathName, FileName1);
    end

	set(gcf,'PaperPositionMode','auto')
	print(fig1,[FileName2 '.tif'],'-dtiff','-r300')
	close
	clearvars ag ka ai str fig1 
        
	subPop = imread([FileName2 '.tif']);
	subPop_gr = rgb2gray(subPop);
	clearvars FileName1 FileName2
        
	fige = figure();
 	imshow(subPop);
  	hold on
 	h = imshow(BaseGr);
   	hold off

  	[M, N] =  size(BaseGr);

 	[row1, col1] = find(BaseGr < 255);
 	rowcol1 = [row1, col1];
  	[row, col] = find(subPop_gr < 255);
  	rowcol = [row, col];

  	allo1 = ones(M,N);
 	for g = 1:size(row1,1)
        allo1(row1(g,1),col1(g,1)) = 0.4;
    end
 	for g = 1:size(row,1)
        allo1(row(g,1),col(g,1)) = 0;
  	end
    set(h, 'AlphaData', allo1);
        
	str = 'Overlay';
 	ka = '_MaxCellDensity_';
    
  	if saveID == 1
        FileName1 = [FileName(1:end-4) ka str];
        FileName2 = fullfile(pathname, FileName1);
    else
        FileName1 = [FileName(1:end-4) ka str];
        FileName2 = fullfile(PathName, FileName1);
    end
    
  	print(fige,[FileName2 '.tif'],'-dtiff','-r300')
  	close(fige)
  	clearvars ag ka ai str FileName1 FileName2 subPop...
        subPop_gr fig1 h M N allo row col rowcol row1 col1 rowcol1 allo1 fige
        
end
